diff --git a/pgadmin/utils/sshTunnel.cpp b/pgadmin/utils/sshTunnel.cpp
new file mode 100644
index 0000000..3addc50
--- /dev/null
+++ b/pgadmin/utils/sshTunnel.cpp
@@ -0,0 +1,409 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+//
+// Copyright (C) 2002 - 2012, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+// sshTunnel.cpp - Used to create SSH Tunnel
+//
+//////////////////////////////////////////////////////////////////////////
+
+// App headers
+#include "pgAdmin3.h"
+#include "utils/sshTunnel.h"
+
+CSSHTunnelThread::CSSHTunnelThread(const wxString tunnelhost, const wxString remote_desthost, const unsigned int remote_destport,
+                                   const wxString username, const wxString password, const wxString publickey, const wxString privatekey,
+                                   const enAuthenticationMethod& enAuthMethod)
+		: m_tunnelhost(tunnelhost), m_remote_desthost(remote_desthost), m_remote_destport(remote_destport), m_username(username),
+		m_password(password), m_publickey(publickey), m_privatekey(privatekey), m_enAuthMethod(enAuthMethod)
+{
+	m_local_listenip = wxEmptyString;
+	m_local_listenport = 0;
+	m_listensock = -1, m_sock = -1, m_forwardsock = -1;
+	m_channel = NULL;
+	m_session = NULL;
+}
+
+CSSHTunnelThread::~CSSHTunnelThread(void)
+{
+}
+
+bool CSSHTunnelThread::Initialize()
+{
+	int rc, auth = AUTH_NONE;
+	const char *fingerprint;
+	char *userauthlist;
+
+#ifdef WIN32
+	char sockopt;
+	WSADATA wsadata;
+
+	WSAStartup(MAKEWORD(2, 0), &wsadata);
+#else
+	int sockopt;
+#endif
+
+	wxArrayString arrTunnelHostIP;
+	long errorno = resolveDNS(m_tunnelhost.mb_str(), arrTunnelHostIP);
+
+	if (errorno == 0)
+	{
+		/* Connect to SSH server */
+		m_sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
+		m_sin.sin_family = AF_INET;
+		if (INADDR_NONE == (m_sin.sin_addr.s_addr = inet_addr(arrTunnelHostIP.Item(0).mb_str())))
+		{
+			wxLogError(_("SSH error: Error in inet address!\n"));
+			return false;
+		}
+		m_sin.sin_port = htons(22);
+		if (connect(m_sock, (struct sockaddr*)(&m_sin),
+		            sizeof(struct sockaddr_in)) != 0)
+		{
+			wxLogError(_("SSH error: Could not connect to socket"));
+			return false;
+		}
+
+		/* Create a session instance */
+		m_session = libssh2_session_init();
+
+		if (!m_session)
+		{
+			wxLogError(_("SSH error: Could not initialize SSH session!\n"));
+			return false;
+		}
+
+		/* ... start it up. This will trade welcome banners, exchange keys,
+		* and setup crypto, compression, and MAC layers
+		*/
+#ifdef HAVE_LIBSSH2_HANDSHAKE_FUNC
+		rc = libssh2_session_handshake(m_session, m_sock);
+#else
+		rc = libssh2_session_startup(m_session, m_sock);
+#endif
+		if (rc)
+		{
+			wxLogError(_("SSH error: Error when starting up SSH session: %d\n"), rc);
+			return false;
+		}
+
+		/* At this point we havn't yet authenticated.  The first thing to do
+		* is check the hostkey's fingerprint against our known hosts Your app
+		* may have it hard coded, may go to a file, may present it to the
+		* user, that's your call
+		*/
+		fingerprint = libssh2_hostkey_hash(m_session, LIBSSH2_HOSTKEY_HASH_SHA1);
+
+		/* check what authentication methods are available */
+		userauthlist = libssh2_userauth_list(m_session, m_username.mb_str(), strlen(m_username.mb_str()));
+
+		if (strstr(userauthlist, "password"))
+			auth |= AUTH_PASSWORD;
+		if (strstr(userauthlist, "publickey"))
+			auth |= AUTH_PUBLICKEY;
+
+		if ((auth & AUTH_PASSWORD) && (m_enAuthMethod == AUTH_PASSWORD))
+			auth = AUTH_PASSWORD;
+		if ((auth & AUTH_PUBLICKEY) && (m_enAuthMethod == AUTH_PUBLICKEY))
+			auth = AUTH_PUBLICKEY;
+
+		if (auth & AUTH_PASSWORD)
+		{
+			rc = libssh2_userauth_password(m_session, m_username.mb_str(), m_password.mb_str());
+			if (rc)
+			{
+				wxLogError(_("SSH error: Authentication by password failed with error code %d\n"), rc);
+				Cleanup();
+				return false;
+			}
+		}
+		else if (auth & AUTH_PUBLICKEY)
+		{
+#ifdef IS_LIBSSH2_OPENSSL_CRYPTO
+			rc = libssh2_userauth_publickey_fromfile(m_session, m_username.mb_str(), NULL, m_privatekey.mb_str(), m_password.mb_str());
+#else
+			rc = libssh2_userauth_publickey_fromfile(m_session, m_username.mb_str(), m_publickey.mb_str(), m_privatekey.mb_str(), m_password.mb_str());
+#endif
+			if (rc)
+			{
+				wxLogError(_("SSH error: Authentication by identity file failed with error code %d\n"), rc);
+				Cleanup();
+				return false;
+			}
+		}
+		else
+		{
+			wxLogError(_("SSH error: No supported authentication methods found!\n"));
+			Cleanup();
+			return false;
+		}
+
+		//Get the IP Address of local machine
+		char hostname[256];
+		gethostname(hostname, sizeof(hostname));
+		wxArrayString arrLocalIP;
+		resolveDNS(hostname, arrLocalIP);
+
+		m_listensock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
+		m_sin.sin_family = AF_INET;
+		// Give port no to 0 so that bind will automatically select the available port.
+		m_sin.sin_port = htons(0);
+		if (INADDR_NONE == (m_sin.sin_addr.s_addr = inet_addr(arrLocalIP.Item(0).mb_str())))
+		{
+			wxLogError(_("SSH error: inet_addr failed"));
+			Cleanup();
+			return false;
+		}
+
+		sockopt = 1;
+		setsockopt(m_listensock, SOL_SOCKET, SO_REUSEADDR, &sockopt, sizeof(sockopt));
+		m_sinlen = sizeof(m_sin);
+		if (-1 == bind(m_listensock, (struct sockaddr *)&m_sin, m_sinlen))
+		{
+			wxLogError(_("SSH error: bind failed"));
+			Cleanup();
+			return false;
+		}
+		if (getsockname(m_listensock, (struct sockaddr *)&m_sin, &m_sinlen) == -1)
+		{
+			wxLogError(_("SSH error: getsockname() failed"));
+			Cleanup();
+			return false;
+		}
+
+		if (-1 == listen(m_listensock, 2))
+		{
+			wxLogError(_("SSH error: listen failed"));
+			Cleanup();
+			return false;
+		}
+
+		m_local_listenip = wxString(inet_ntoa(m_sin.sin_addr), wxConvLibc);
+		m_local_listenport = ntohs(m_sin.sin_port);
+
+		wxLogInfo(wxT("Waiting for TCP connection on %s:%d...\n"),
+		          m_local_listenip.c_str(), m_local_listenport);
+
+		return true;
+	}
+	else
+	{
+		wxLogError(_("SSH error: Unable to resolve host: %s with error code %d\n"), m_tunnelhost.c_str(), errorno);
+	}
+
+	return false;
+}
+
+void * CSSHTunnelThread::Entry()
+{
+	while (1)
+	{
+		m_forwardsock = accept(m_listensock, (struct sockaddr *) & m_sin, &m_sinlen);
+		if (-1 == m_forwardsock)
+		{
+			wxLogError(_("SSH error: accept failed"));
+			Cleanup();
+			break;
+		}
+		// Create thread for read/write.
+		CSubThread *subThread = new CSubThread(m_sin, m_remote_desthost, m_remote_destport, m_session, m_channel, m_forwardsock);
+		if ( subThread->Create() != wxTHREAD_NO_ERROR )
+		{
+			delete subThread;
+			subThread = NULL;
+		}
+		else
+		{
+			if (subThread->Run() != wxTHREAD_NO_ERROR )
+			{
+				delete subThread;
+				subThread = NULL;
+			}
+		}
+	}
+
+	return NULL;
+}
+
+void CSSHTunnelThread::Cleanup()
+{
+
+#ifdef WIN32
+	closesocket(m_forwardsock);
+	closesocket(m_listensock);
+#else
+	close(m_forwardsock);
+	close(m_listensock);
+#endif
+
+	if (m_channel)
+		libssh2_channel_free(m_channel);
+
+	libssh2_session_disconnect(m_session, "Client disconnecting normally");
+
+	libssh2_session_free(m_session);
+
+#ifdef WIN32
+	closesocket(m_sock);
+#else
+	close(m_sock);
+#endif
+
+#ifdef HAVE_LIBSSH2_EXIT_FUNC
+	libssh2_exit();
+#endif
+}
+
+long CSSHTunnelThread::resolveDNS(const char * host, wxArrayString &arrIPAddress)
+{
+	long errorno = 0;
+	struct in_addr addr;
+	struct hostent* remoteHost = gethostbyname(host);
+	if (remoteHost != NULL)
+	{
+		if (remoteHost->h_addrtype == AF_INET)
+		{
+			int i = 0;
+			while (remoteHost->h_addr_list[i] != 0)
+			{
+				addr.s_addr = *(u_long *) remoteHost->h_addr_list[i++];
+				arrIPAddress.Add(wxString((char*) inet_ntoa(addr), wxConvLocal));
+			}
+		}
+	}
+	else
+	{
+#ifdef WIN32
+		errorno = GetLastError();
+#else
+		errorno = errno;
+#endif
+	}
+
+	return errorno;
+}
+
+CSubThread::CSubThread(const struct sockaddr_in sin, const wxString remote_desthost, const unsigned int remote_destport,
+                       LIBSSH2_SESSION *session, LIBSSH2_CHANNEL *channel, int forwardsock)
+		: m_sin(sin), m_remote_desthost(remote_desthost), m_remote_destport(remote_destport),
+		m_session(session), m_channel(channel), m_forwardsock(forwardsock)
+{
+}
+
+CSubThread::~CSubThread(void)
+{
+}
+
+void *
+CSubThread::Entry()
+{
+	fd_set fds;
+	struct timeval tv;
+	ssize_t len, wr;
+	char buf[16384];
+	int rc, i = 0;
+
+	const char *shost = inet_ntoa(m_sin.sin_addr);
+	unsigned int sport = ntohs(m_sin.sin_port);
+
+	wxLogInfo(wxT("\nForwarding connection from %s:%d here to remote %s:%d\n"), inet_ntoa(m_sin.sin_addr),
+	          sport, m_remote_desthost.c_str(), m_remote_destport);
+
+	/* Must use blocking here to avoid connect errors */
+	libssh2_session_set_blocking(m_session, 1);
+
+	m_channel = libssh2_channel_direct_tcpip_ex(m_session, m_remote_desthost.mb_str(),
+	            m_remote_destport, shost, sport);
+
+	if (!m_channel)
+	{
+		wxLogError(_("SSH error: Could not open the direct-tcpip channel!\n (Note that this can be a problem at the server! Please review the server logs.)\n"));
+		goto shutdown;
+	}
+
+	/* Must use non-blocking IO hereafter due to the current libssh2 API */
+	libssh2_session_set_blocking(m_session, 0);
+
+	while (1)
+	{
+		FD_ZERO(&fds);
+		FD_SET(m_forwardsock, &fds);
+		tv.tv_sec = 0;
+		tv.tv_usec = 100000;
+		rc = select(m_forwardsock + 1, &fds, NULL, NULL, &tv);
+		if (-1 == rc)
+		{
+			wxLogError(_("SSH error: select failed"));
+			goto shutdown;
+		}
+		if (rc && FD_ISSET(m_forwardsock, &fds))
+		{
+			len = recv(m_forwardsock, buf, sizeof(buf), 0);
+			if (len < 0)
+			{
+				wxLogError(_("SSH error: read failed"));
+				goto shutdown;
+			}
+			else if (0 == len)
+			{
+				wxLogInfo(_("The client at %s:%d disconnected!\n"), shost, sport);
+				goto shutdown;
+			}
+			wr = 0;
+			do
+			{
+				i = libssh2_channel_write(m_channel, buf, len);
+
+				if (i < 0)
+				{
+					wxLogError(_("SSH error: libssh2_channel_write: %d\n"), i);
+					goto shutdown;
+				}
+				wr += i;
+			}
+			while (i > 0 && wr < len);
+		}
+		while (1)
+		{
+			len = libssh2_channel_read(m_channel, buf, sizeof(buf));
+
+			if (LIBSSH2_ERROR_EAGAIN == len)
+				break;
+			else if (len < 0)
+			{
+				wxLogError(_("SSH error: libssh2_channel_read: %d"), (int)len);
+				goto shutdown;
+			}
+			wr = 0;
+			while (wr < len)
+			{
+				i = send(m_forwardsock, buf + wr, len - wr, 0);
+				if (i <= 0)
+				{
+					wxLogError(_("SSH error: write failed"));
+					goto shutdown;
+				}
+				wr += i;
+			}
+			if (libssh2_channel_eof(m_channel))
+			{
+				wxLogInfo(_("The server at %s:%d disconnected!\n"),
+				          m_remote_desthost.c_str(), m_remote_destport);
+				goto shutdown;
+			}
+		}
+	}
+shutdown:
+#ifdef WIN32
+	closesocket(m_forwardsock);
+#else
+	close(m_forwardsock);
+#endif
+
+	if (m_channel)
+		libssh2_channel_free(m_channel);
+
+	return NULL;
+}
